/***********************************************
 *
 * OG Script Dumper v2.51 by learn_more
 * File: out\a182\script\cam_dump.as
 * Generated: 11-Jun-2012 19:15:40
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3b57a0 (0x7b57a0)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc0b80 (0x4c0b80)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc0bb0 (0x4c0bb0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b5c20 (0x7b5c20)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3b6360 (0x7b6360)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b60f0 (0x7b60f0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b5fe0 (0x7b5fe0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b63c0 (0x7b63c0)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3b5eb0 (0x7b5eb0)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b5bd0 (0x7b5bd0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b6390 (0x7b6390)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3b5c50 (0x7b5c50)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3b5d80 (0x7b5d80)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3b57f0 (0x7b57f0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3b52c0 (0x7b52c0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x24c490 (0x64c490)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x24b310 (0x64b310)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x24b370 (0x64b370)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x24c2a0 (0x64c2a0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x24c310 (0x64c310)
	void Update();		// 'Overgrowth.exe' + 0x250350 (0x650350)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2aac20 (0x6aac20)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2aabd0 (0x6aabd0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x37c4b0 (0x77c4b0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x37c310 (0x77c310)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x37c2a0 (0x77c2a0)
	float GetLens();		// 'Overgrowth.exe' + 0x37c2f0 (0x77c2f0)
	void Update();		// 'Overgrowth.exe' + 0x37c930 (0x77c930)
	bool valid();		// 'Overgrowth.exe' + 0x37a870 (0x77a870)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x151ba4e0
SphereCollision sphere_col;		// 0x151ba4e4
GUI gui;		// 0x1ba66ea8
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x434bf8 (0x834bf8)
CameraObject co;		// 0x1da870d0
CameraAnimationReader camera_animation_reader;		// 0x1da871bc
